// --------------- note setup ----------------------------------
// Note Code
// ---------------------------------------------------------------------- 동요: 겨울밤
uint8_t Tempo = 120; // 1, 1박자 = 1000/(tempoRatio), 비트수 = 2 = 2000
uint8_t tempoRatio = Tempo/60;
uint8_t KeySign = 0; //  0 ~ 14, flat: 1 ~ 7, sharp: 8 ~ 14
uint8_t octaveTemp = 4; // 조표 변화시 옥타브 변경에 사용
//float beatTime = 2/4; // 박자표 - 멜로디 코드에서는 사용하지 않는다.

const note_t Mnote[] PROGMEM= { // 겨울밤
NOTE_G, NOTE_G, NOTE_G, NOTE_A, NOTE_G, NOTE_F, NOTE_E, NOTE_E, NOTE_E, NOTE_MAX,
NOTE_F, NOTE_F, NOTE_F, NOTE_G, NOTE_F, NOTE_E, NOTE_D, NOTE_D, NOTE_D, NOTE_MAX,
NOTE_C, NOTE_D, NOTE_E, NOTE_F, NOTE_G, NOTE_G, NOTE_G, NOTE_A, NOTE_G, NOTE_MAX,
NOTE_C, NOTE_G, NOTE_G, NOTE_A, NOTE_G, NOTE_F, NOTE_E, NOTE_F, NOTE_G, NOTE_MAX,
NOTE_C, NOTE_G, NOTE_G, NOTE_A, NOTE_G, NOTE_F, NOTE_E, NOTE_D, NOTE_C, NOTE_MAX,
};

const uint8_t Moct[] PROGMEM= { // 멜로디 옥타브 C ~ B, 4옥타브: 88키보드 가운데 도(C4) ~ 시(B4)
4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
5, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
5, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
0,
};

const uint8_t localKey[] PROGMEM= {
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
0,
};

const uint8_t Mdur[] PROGMEM= {
16, 
4, 4, 2, 2, 2, 2, 4, 4, 4, 4, 
4, 4, 2, 2, 2, 2, 4, 4, 4, 4, 
4, 4, 4, 4, 2, 2, 2, 2, 4, 4, 
4, 4, 2, 2, 2, 2, 4, 4, 4, 4, 
4, 4, 2, 2, 2, 2, 4, 4, 4, 4, 
};
// ----------------------------------------------------------------------

uint8_t noteNum = 0;

note_t keySignature(note_t note) {
  if (localKey[noteNum] == 0) {
    if (KeySign == 1) { // F Major (바장조)
      if (note == NOTE_B) note = NOTE_Bb;
    } else if (KeySign == 2) { // B E - 마지막 E의 앞 조표가(B) Key -> Bb Major(나장조)
      if (note == NOTE_B) note = NOTE_Bb;
      else if (note == NOTE_E) note = NOTE_Eb;
    } else if (KeySign == 3) {
      if (note == NOTE_B) note = NOTE_Bb;
      else if (note == NOTE_E) note = NOTE_Eb;
      else if (note == NOTE_A) note = NOTE_Gs;
    } else if (KeySign == 4) { // 
      if (note == NOTE_B) note = NOTE_Bb;
      else if (note == NOTE_E) note = NOTE_Eb;
      else if (note == NOTE_A) note = NOTE_Gs;
      else if (note == NOTE_D) note = NOTE_Cs;
    } else if (KeySign == 5) { // B E A D G - 마지막 G의 앞 조표가(D) Key -> Db Major(내림라장조)
      if (note == NOTE_B) note = NOTE_Bb;
      else if (note == NOTE_E) note = NOTE_Eb;
      else if (note == NOTE_A) note = NOTE_Gs;
      else if (note == NOTE_D) note = NOTE_Cs;
      else if (note == NOTE_G) note = NOTE_Fs;
    } else if (KeySign == 6) {
      if (note == NOTE_B) note = NOTE_Bb;
      else if (note == NOTE_E) note = NOTE_Eb;
      else if (note == NOTE_A) note = NOTE_Gs;
      else if (note == NOTE_D) note = NOTE_Cs;
      else if (note == NOTE_G) note = NOTE_Fs;
      else if (note == NOTE_C) { note = NOTE_B; octaveTemp -= 1; }
    } else if (KeySign == 7) { //
      if (note == NOTE_B) note = NOTE_Bb;
      else if (note == NOTE_E) note = NOTE_Eb;
      else if (note == NOTE_A) note = NOTE_Gs;
      else if (note == NOTE_D) note = NOTE_Cs;
      else if (note == NOTE_G) note = NOTE_Fs;
      else if (note == NOTE_C) { note = NOTE_B; octaveTemp -= 1; }
      else if (note == NOTE_F) note = NOTE_E;
    } else if (KeySign == 8) { // F에서 한음 올린다 -> G Mager key(사장조)
      if (note == NOTE_F) note = NOTE_Fs;
    } else if (KeySign == 9) {
      if (note == NOTE_F) note = NOTE_Fs;
      else if (note == NOTE_C) note = NOTE_Cs;
    } else if (KeySign == 10) {
      if (note == NOTE_F) note = NOTE_Fs;
      else if (note == NOTE_C) note = NOTE_Cs;
      else if (note == NOTE_G) note = NOTE_Gs;
    } else if (KeySign == 11) { // F C G D - 마지막 D(레)에서 한음 올린다 -> E Major key(마장조)
      if (note == NOTE_F) note = NOTE_Fs;
      else if (note == NOTE_C) note = NOTE_Cs;
      else if (note == NOTE_G) note = NOTE_Gs;
      else if (note == NOTE_D) note = NOTE_Eb;
    } else if (KeySign == 12) {
      if (note == NOTE_F) note = NOTE_Fs;
      else if (note == NOTE_C) note = NOTE_Cs;
      else if (note == NOTE_G) note = NOTE_Gs;
      else if (note == NOTE_D) note = NOTE_Eb;
      else if (note == NOTE_A) note = NOTE_Bb;
    } else if (KeySign == 13) {
      if (note == NOTE_F) note = NOTE_Fs;
      else if (note == NOTE_C) note = NOTE_Cs;
      else if (note == NOTE_G) note = NOTE_Gs;
      else if (note == NOTE_D) note = NOTE_Eb;
      else if (note == NOTE_A) note = NOTE_Bb;
      else if (note == NOTE_E) note = NOTE_F;
    } else if (KeySign == 14) { // F C G D A E B - 마지막 B(시)에서 한음 올린다 -> C이지만 앞에서 이미 C를 올렸으므로 C# Major (올림 다장조)
      if (note == NOTE_F) note = NOTE_Fs;
      else if (note == NOTE_C) note = NOTE_Cs;
      else if (note == NOTE_G) note = NOTE_Gs;
      else if (note == NOTE_D) note = NOTE_Eb;
      else if (note == NOTE_A) note = NOTE_Bb;
      else if (note == NOTE_E) note = NOTE_F;
      else if (note == NOTE_B) { note = NOTE_C; octaveTemp += 1; }
    }
  }
  else { // 1. natural
    if (localKey[noteNum] == 2) { // 2. b
      if (note == NOTE_C) { note = NOTE_B; octaveTemp -= 1; }
      else if (note == NOTE_D) note = NOTE_Cs;
      else if (note == NOTE_E) note = NOTE_Eb;
      else if (note == NOTE_F) note = NOTE_E;
      else if (note == NOTE_G) note = NOTE_Fs;
      else if (note == NOTE_A) note = NOTE_Gs;
      else if (note == NOTE_B) note = NOTE_Bb;
    }
    else if (localKey[noteNum] == 3) { // 3. #
      if (note == NOTE_C) note = NOTE_Cs;
      else if (note == NOTE_D) note = NOTE_Eb;
      else if (note == NOTE_E) note = NOTE_F;
      else if (note == NOTE_F) note = NOTE_Fs;
      else if (note == NOTE_G) note = NOTE_Gs;
      else if (note == NOTE_A) note = NOTE_Bb;
      else if (note == NOTE_B) { note = NOTE_C; octaveTemp += 1; }
    }
    else if (localKey[noteNum] == 4) { // 4. bb
      if (note == NOTE_C) { note = NOTE_Bb; octaveTemp -= 1; }
      else if (note == NOTE_D) note = NOTE_C;
      else if (note == NOTE_E) note = NOTE_D;
      else if (note == NOTE_F) note = NOTE_Eb;
      else if (note == NOTE_G) note = NOTE_F;
      else if (note == NOTE_A) note = NOTE_G;
      else if (note == NOTE_B) note = NOTE_A;
    }
    else if (localKey[noteNum] == 5) { // 5. ##
      if (note == NOTE_C) note = NOTE_D;
      else if (note == NOTE_D) note = NOTE_E;
      else if (note == NOTE_E) note = NOTE_Fs;
      else if (note == NOTE_F) note = NOTE_G;
      else if (note == NOTE_G) note = NOTE_A;
      else if (note == NOTE_A) note = NOTE_B;
      else if (note == NOTE_B) { note = NOTE_Cs; octaveTemp += 1; }
    }
  }
  return note;
}

note_t noteConvertor(uint8_t note) {
  note_t temp;
  if (note < 7) {
    if (note == 0) temp = NOTE_MAX;
    else if (note == 1) temp = NOTE_C;
    else if (note == 2) temp = NOTE_Cs;
    else if (note == 3) temp = NOTE_D;
    else if (note == 4) temp = NOTE_Eb;
    else if (note == 5) temp = NOTE_E;
    else if (note == 6) temp = NOTE_F;
  } else {
    if (note == 7) temp = NOTE_Fs;
    else if (note == 8) temp = NOTE_G;
    else if (note == 9) temp = NOTE_Gs;
    else if (note == 10) temp = NOTE_A;
    else if (note == 11) temp = NOTE_Bb;
    else if (note == 12) temp = NOTE_B;
  }
  return temp;
}
// --------------- note setup ----------------------------------

#include <WiFi.h>
#include <WiFiAP.h>
#include <WiFiClient.h>
WiFiServer server(80);
#include <EEPROM.h>
#define EEPROM_SIZE 1024

char ssid[21] = "skynet";    // "SK_WiFiGIGA40F7" your network SSID (name)
char pass[21] = "skynet00";  // "1712037218" your network password

char ssidAP[21] = "LED Clock";    // your network SSID (name)
char passAP[21] = "";             // your network password

int beepPin = 4;

void setup() {
  Serial.begin(115200);
  ledcSetup(0,1E5,12);  // ESP32 톤전용 ledcSetup: ledcSetup(channel,1E5,12);
  ledcAttachPin(beepPin,0);  // ledcAttachPin(uint8_t pin, uint8_t channel);
  if (!EEPROM.begin(EEPROM_SIZE)) {
    Serial.println("failed to initialise EEPROM");
  }
  WiFi.mode(WIFI_AP_STA);  
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, pass);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("WiFi connected");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
  WiFi.softAP(ssidAP, passAP);
  Serial.print(F("AP Address: "));
  Serial.println(WiFi.softAPIP());
  server.begin();  
}

bool beepMelody = false;
unsigned long int beepTime = 0;

uint16_t noteTTL = 10; // 2,3
const uint8_t noteSt = 4;
uint16_t octSt = 18;   // noteTTL+noteSt
uint16_t durSt = 29;   // noteTTL+octSt+1

bool eepromMelody = false;
uint8_t eepromDur = 0;

void wifi() {
  WiFiClient client = server.available();  // listen for incoming clients
  if (client.available()) {  
    String line = client.readStringUntil('\n');
    String temp = line.substring(5, 9); // "GET /%%F0"
    if (temp == F("%%F0")) { // GET /%%F0tempo,notenum%(note,...)%(oct,...)%(dur,...)\n
      temp = line.substring(9, 12);
      if (temp == F("%S%")) {
        eepromMelody = false;
        ledcWrite(0,0);
      } 
      else if (temp == F("%P%")) {
        eepromMelody = true;
        noteNum = 0; beepTime = 0;
        Tempo = EEPROM.read(1);
        noteTTL = EEPROM.readShort(2); //EEPROM.get(2);
        octSt = noteTTL+noteSt;  
        durSt = noteTTL+octSt+1; 
        tempoRatio = Tempo/60;
        eepromDur = EEPROM.read(durSt+noteNum);
      } 
      else {
        uint8_t value = 0;
        uint16_t indexSt = 9;
        uint16_t indexEd = line.indexOf(F(","));
        String temp = line.substring(indexSt, indexEd);
        value = temp.toInt();
        Tempo = value;    
        indexSt = line.indexOf(F("%"),indexEd);
        temp = line.substring(indexEd+1,indexSt);
        value = temp.toInt();
        noteTTL = value;
        octSt = noteTTL+noteSt;  
        durSt = noteTTL+octSt+1; 
        EEPROM.write(1,Tempo);
        EEPROM.put(2,noteTTL);
        uint8_t indexDel = line.lastIndexOf(F("%"));
        indexSt = indexDel+1;
        for (int i = 0; i < noteTTL+1; i++) {
          indexEd = line.indexOf(F(","), indexSt);
          temp = line.substring(indexSt, indexEd);
          value = temp.toInt();
          EEPROM.write(durSt+i,value);
          indexSt = indexEd+1;
        }
        line.remove(indexDel);
        indexDel = line.lastIndexOf(F("%"));
        indexSt = indexDel+1;
        for (int i = 0; i < noteTTL+1; i++) {
          indexEd = line.indexOf(F(","), indexSt);
          temp = line.substring(indexSt, indexEd);
          value = temp.toInt();
          EEPROM.write(octSt+i,value);
          indexSt = indexEd+1;
        }
        line.remove(indexDel);
        indexDel = line.lastIndexOf(F("%"));
        indexSt = indexDel+1;
        for (int i = 0; i < noteTTL; i++) {
          indexEd = line.indexOf(F(","), indexSt);
          temp = line.substring(indexSt, indexEd);
          value = temp.toInt();
          EEPROM.write(noteSt+i,value);
          indexSt = indexEd+1;
        }
        EEPROM.commit();
        if (beepMelody) beepMelody = false;
        eepromMelody = true;
      }
      client.println(F("HTTP/1.1 200 OK\nContent-type:text/html\nConnection: close\r\n"));
      client.println(F("%M%"));
    } else {
      client.println(F("HTTP/1.1 200 OK\nContent-type:text/html\nConnection: close\r\n"));
      client.println(F("%C%"));
    }
    client.stop();
  }
}

void loop() {
  wifi();
  if (beepMelody) {
    if (millis() - beepTime >= Mdur[noteNum]*(1000/(4*tempoRatio))) {
      beepTime = millis();
      ledcWrite(0,0); 
      octaveTemp = Moct[noteNum];
      note_t KeyNote = keySignature(Mnote[noteNum]);
      ledcWriteNote(0, KeyNote, octaveTemp);  // ledcWriteNote(uint8_t channel, note_t note, uint8_t octaveTemp);
      noteNum++;
      if (noteNum == sizeof(Mdur)) { // 초기화
        ledcWrite(0,0);  //  noTone() - ledcWrite(uint8_t channel, uint32_t duty);
        noteNum = 0; 
      }
    }
  }
  else if (eepromMelody) {
    if (millis() - beepTime >= eepromDur*(1000/(4*tempoRatio))) {
      beepTime = millis();
      ledcWrite(0,0); 
      octaveTemp = EEPROM.read(octSt+noteNum);
      note_t KeyNote = noteConvertor(EEPROM.read(noteSt+noteNum));
      ledcWriteNote(0, KeyNote, octaveTemp);  // ledcWriteNote(uint8_t channel, note_t note, uint8_t octaveTemp);
      noteNum++;
      if (noteNum == noteTTL+1) { // 초기화
        ledcWrite(0,0);  //  noTone() - ledcWrite(uint8_t channel, uint32_t duty);
        noteNum = 0; 
      }
      eepromDur = EEPROM.read(durSt+noteNum);
    }
  }
  if(Serial.available() > 0){
    String temp = Serial.readStringUntil('\n');
    Serial.println(temp);
    if (temp == "0") {
      beepMelody = !beepMelody;
      noteNum = 0; beepTime = 0;
      if (!beepMelody) ledcWrite(0,0);  
      eepromMelody = false;
    }
    else if (temp == "1") {
      eepromMelody = !eepromMelody;
      noteNum = 0; beepTime = 0;
      Tempo = EEPROM.read(1);
      noteTTL = EEPROM.readShort(2); //EEPROM.get(2);
      octSt = noteTTL+noteSt;  
      durSt = noteTTL+octSt+1; 
      tempoRatio = Tempo/60;
      eepromDur = EEPROM.read(durSt+noteNum);
    }
    else if (temp == "2") {
      beepMelody = false;
      eepromMelody = false;
      ledcWrite(0,0);
    }
  }
}
